Syncfusion AI Assistant

How can I help you?

Group in EJ2 JavaScript Diagram control

29 Jan 202524 minutes to read

Create group

Group is used to cluster multiple nodes and connectors into a single element. It acts like a container for its children (nodes, groups, and connectors). Every change made to the group also affects the children. Child elements can be edited individually.

Add group when initializing diagram

A group can be added to the diagram model through nodes collection. To define an object as group, add the child objects to the children collection of the group. The following code illustrates how to create a group node.

  • While creating group, its child node need to be declared before the group declaration.
var nodes = [{
        id: "rectangle1",
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7'
        },
        annotations: [{
            content: 'rectangle1'
        }]
    }, {
        id: "rectangle2",
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7'
        },
        annotations: [{
            content: 'rectangle2'
        }]
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    },

];

var diagram = new ej.diagrams.Diagram({
    width: '1500px',
    height: '600px',
    getNodeDefaults: function(node) {
        node.height = 100;
        node.width = 100;
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
    },
    nodes: nodes,
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Group nodes at runtime

Groups can be dynamically created during runtime in the diagram by invoking the diagram.group method. To initiate this process, first, select the nodes that you intend to include within the group. Subsequently, by utilizing the diagram.group method, the selected nodes will be encapsulated within a newly formed group node.

The following code illustrates how a group at runtime.

var diagram;
let node = {
  id: 'node1',
  width: 100,
  height: 100,
  offsetX: 100,
  offsetY: 100,
  annotations: [{ content: 'Node1' }],
};
let node2 = {
  id: 'node2',
  width: 100,
  height: 100,
  offsetX: 200,
  offsetY: 200,
  annotations: [{ content: 'Node2' }],
};
let node3 = {
  id: 'node3',
  width: 100,
  height: 100,
  offsetX: 300,
  offsetY: 300,
  annotations: [{ content: 'Node3' }],
};

//Initializes diagram control
diagram = new ej.diagrams.Diagram(
  {
    width: 900,
    height: 900,
    nodes: [node, node2, node3],
  },
  '#element'
);
diagram.selectAll();

document.getElementById('group').onclick = function () {
  diagram.group();
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="group selected nodes" id="group"/>
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

UnGroup nodes at runtime

Group node can be unGrouped dynamically, by using the diagram.unGroup method. The following code example shows how to unGroup group node at runtime.

var nodes = [
    {
      id: 'rectangle1',
      offsetX: 100,
      offsetY: 100,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle1',
        },
      ],
    },
    {
      id: 'rectangle2',
      offsetX: 200,
      offsetY: 200,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle2',
        },
      ],
    },
    {
      id: 'group',
      children: ['rectangle1', 'rectangle2'],
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '1500px',
      height: '600px',
      nodes: nodes,
    },
    '#element'
  );
  diagram.select([diagram.nameTable['group']]);
  
  document.getElementById('unGroup').onclick = () => {
    diagram.unGroup();
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="unGroup" id="unGroup" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Add group node at runtime

A group node can be added at runtime by using the diagram method add.

The following code illustrates how a group node is added at runtime.

var nodes = [
    {
      id: 'rectangle1',
      offsetX: 100,
      offsetY: 100,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle1',
        },
      ],
    },
    {
      id: 'rectangle2',
      offsetX: 200,
      offsetY: 200,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle2',
        },
      ],
    },
  ];
  
  var group = {
    id: 'group',
    children: ['rectangle1', 'rectangle2'],
    style: { strokeColor: 'green' },
  };
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '1500px',
      height: '600px',
      nodes: nodes,
    },
    '#element'
  );
  diagram.add(group);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Add collection of group nodes at runtime

  • The collection of group nodes can be dynamically added using ‘addElements’ method.Each time an element is added to the diagram canvas, the ‘collectionChange’ event will be triggered.

The following code illustrates how to add a group nodes collection at runtime.

var diagram;
var node = [
    { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group', children: ['rectangle1', 'rectangle2'] },
    { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group2', children: ['rectangle3', 'rectangle4'], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
];
//Initializes diagram control
diagram = new ej.diagrams.Diagram({
    width: 900,
    height: 900,
  }, '#element');
//Add collection of group nodes
diagram.addElements(node);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Add/Remove children from group

Add children To group at runtime

A child node can be added to the specified Group at runtime by utilizing the diagram method addChildToGroup.

This functionality is achieved by passing the group and existing children as arguments to the method.

The following code illustrates how a child node and a group node can be passed as arguments to the method and executed at runtime.

diagram.addChildToGroup(groupNode, childNode);

Remove children from group at runtime

A specific child from a group node can be removed at runtime by utilizing the diagram method removeChildFromGroup.

This functionality is achieved by passing the group and its children as arguments to the method.

The following code illustrates how a child node is removed from a group at runtime.

diagram.removeChildFromGroup (groupNode, childNode);
var diagram;
var node = {
  id: 'node1', width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
};
var node2 = {
  id: 'node2', width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
};
var group = {
  id: 'group1', children: ['node1', 'node2']
};
var node3 = {
  id: 'node3', width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
};

//Initializes diagram control
diagram = new ej.diagrams.Diagram({
  width: 900,
  height: 900,
  nodes: [node, node2, node3,group],

}, '#element');

//To Add child to specifc group at Runtime
document.getElementById('addChildToGroup').onclick = () =>{
  diagram.addChildToGroup(group, 'node3');
}

//To remove the specific children from group at runtime
document.getElementById('removeChildFromGroup').onclick = () =>{
  diagram.removeChildFromGroup(group, 'node3');
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="addChildToGroup" id="addChildToGroup" />
            <input type="button" value="removeChildFromGroup" id="removeChildFromGroup" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Group padding

The Padding property of a group node defines the spacing between the group node’s edges and its children.

The following code illustrates how to add Padding to the node group.

var diagram;
var node = {
  id: 'node1',
  width: 100,
  height: 100,
  offsetX: 100,
  offsetY: 100,
  annotations: [{ content: 'Node1' }],
};
var node2 = {
  id: 'node2',
  width: 100,
  height: 100,
  offsetX: 200,
  offsetY: 200,
  annotations: [{ content: 'Node2' }],
};
var node3 = {
  id: 'node3',
  width: 100,
  height: 100,
  offsetX: 300,
  offsetY: 300,
  annotations: [{ content: 'Node3' }],
};
var group = {
  id: 'group',
  children: ['node1', 'node2', 'node3'],
  padding: { left: 20, right: 20, top: 20, bottom: 20 },
  // style: { strokeColor: 'green' },
};

//Initializes diagram control
diagram = new ej.diagrams.Diagram(
  {
    width: 900,
    height: 900,
    nodes: [node, node2, node3, group],
  },
  '#element'
);
diagram.select([diagram.nameTable['group']]);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Group flip

The flip functionality for a group node works similarly to that of normal nodes. However, when flipping a group node, the flip of its child nodes is combined with the group’s flip. This combination ensures that the child nodes inherit the group’s flip while retaining their own individual flips.

Example:

  • If a child node’s flip is set to Vertical and the group node’s flip is set to Horizontal, the resulting flip for the child node will be a combination of Vertical and Horizontal (effectively a “both” flip).
  • This ensures that the child nodes’ orientations adapt dynamically based on the group’s flip while maintaining their unique flip settings.

The following example shows how to apply flip for group node.

var diagram;
//Initialize nodes
var nodes = [
  {
    id: 'node1',
    width: 70,
    height: 70,
    offsetX: 100,
    offsetY: 100,
    //Sets the flip as Vertical
    flip: ej.diagrams.FlipDirection.Vertical,
    shape: {
      type: 'Basic',
      shape: 'RightTriangle',
    },
    style: {
      fill: '#6BA5D7',
    },
  },
  {
    id: 'node2',
    width: 70,
    height: 70,
    offsetX: 180,
    offsetY: 180,
    shape: {
      type: 'Basic',
      shape: 'RightTriangle',
    },
    style: {
      fill: '#6BA5D7',
    },

  },
  {
    id: 'group',
    children: ['node1', 'node2',],
    padding: { left: 20, right: 20, top: 20, bottom: 20 },
    //Sets the flip as Horizontal
    flip: ej.diagrams.FlipDirection.Horizontal,
  }
];

//Initializes diagram control
diagram = new ej.diagrams.Diagram(
  {
    width: 900,
    height: 900,
    nodes: nodes,
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Group flip mode

The flipMode of a group node also behave similarly to those of normal nodes. However,When you apply a flip mode to a group node, it takes precedence over any flip mode set on its child nodes, overriding their individual settings.

For example, in the below code,
the flipMode for the child node Node1 is set to LabelText.
The flipMode for the group node is set to Label.
As a result, the effective flipMode for both the child node and the group node will be Label, as the group node’s flipMode overrides the child’s.

var diagram;
//Initialize nodes
var nodes = [
  {
    id: 'node1',
    width: 70,
    height: 70,
    offsetX: 100,
    offsetY: 100,
    //Sets the flip mode as LabelText
    flipMode: 'LabelText',
    annotations: [{ content: 'Node1', offset: { x: 0, y: 0.8 } }],
    shape: {
      type: 'Basic',
      shape: 'RightTriangle',
    },
    style: {
      fill: '#6BA5D7',
    },
  },
  {
    id: 'node2',
    width: 70,
    height: 70,
    offsetX: 180,
    offsetY: 180,
    shape: {
      type: 'Basic',
      shape: 'RightTriangle',
    },
    style: {
      fill: '#6BA5D7',
    },

  },
  {
    id: 'group',
    children: ['node1', 'node2',],
    padding: { left: 20, right: 20, top: 20, bottom: 20 },
    annotations: [{ content: 'Group', offset: { x: 0, y: 0.8 } }],
    //Sets the flip as Horizontal
    flip: ej.diagrams.FlipDirection.Horizontal,
    //Sets the flip mode as Label
    flipMode: 'Label',
  }
];

//Initializes diagram control
diagram = new ej.diagrams.Diagram(
  {
    width: 900,
    height: 900,
    nodes: nodes,
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Nested group

Nested groups are essentially groups within groups, where a group can contain other groups as its children, creating a hierarchy that helps manage complexity and relationships between different elements. The following code illustrates how to create nested group node.

var diagram;
var node = {
  id: 'node1',
  width: 100,
  height: 100,
  offsetX: 100,
  offsetY: 100,
  annotations: [{ content: 'Node1' }],
};
var node2 = {
  id: 'node2',
  width: 100,
  height: 100,
  offsetX: 200,
  offsetY: 200,
  annotations: [{ content: 'Node2' }],
};
var node3 = {
  id: 'node3',
  width: 100,
  height: 100,
  offsetX: 300,
  offsetY: 350,
  annotations: [{ content: 'Node3' }],
};
var node4 = {
  id: 'node4',
  width: 100,
  height: 100,
  offsetX: 500,
  offsetY: 350,
  annotations: [{ content: 'Node4' }],
};
var group1 = {
  id: 'group1',
  children: ['node1', 'node2'],
  padding: { left: 20, right: 20, top: 20, bottom: 20 },
  style: { fill: 'green' },
};
var group2 = {
  id: 'group2',
  children: ['node3', 'node4'],
  padding: { left: 20, right: 20, top: 20, bottom: 20 },
  style: { fill: 'skyblue' },
};
var group3 = {
  id: 'group3',
  children: ['group1', 'group2'],
  padding: { left: 20, right: 20, top: 20, bottom: 20 },
  style: { fill: 'yellow' },
};

//Initializes diagram control
diagram = new ej.diagrams.Diagram(
  {
    width: 900,
    height: 900,
    nodes: [node, node2, node3, node4, group1, group2, group3],
  },
  '#element'
);
diagram.select([diagram.nameTable['group3']]);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Nested Group GIF

Add Group in palette

Group node can be added in symbol palette like the normal nodes. The following code illustrates how to render group node in palette.

let diagram;

let nodes = [
  {
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    visible: true,
    style: { fill: '#6AA8D7', strokeWidth: 1 },
    // Text(label) added to the node
  },
];

//Initializes diagram control
diagram = new ej.diagrams.Diagram({
  width: '70%',
  height: '645px',
  nodes: nodes,
  getNodeDefaults: function (obj) {
    return obj;
  },
  created: created,
});
diagram.appendTo('#element');
function created() {
  diagram.fitToPage({ mode: 'Width' });
}

function getSymbols() {
  let shapes = [
    {
      id: 'n1',
      height: 50,
      width: 50,
      offsetX: 50,
      offsetY: 50,
      style: { fill: 'green' },
    },
    {
      id: 'n2',
      height: 50,
      width: 50,
      offsetX: 100,
      offsetY: 100,
      style: { fill: 'yellow' },
    },
    {
      id: 'group1',
      children: ['n1', 'n2'],
      padding: { left: 10, right: 10, top: 10, bottom: 10 },
    },
    {
      id: 'n3',
      height: 50,
      width: 50,
      offsetX: 200,
      offsetY: 100,
      style: { fill: 'pink' },
    },
    {
      id: 'n4',
      height: 50,
      width: 50,
      offsetX: 200,
      offsetY: 170,
      style: { fill: 'orange' },
    },
    {
      id: 'group2',
      children: ['n3', 'n4'],
      padding: { left: 10, right: 10, top: 10, bottom: 10 },
    },
  ];
  return shapes;
}

let palette = new ej.diagrams.SymbolPalette({
  // symbolHeight: 70,
  // symbolWidth: 70,
  palettes: [
    {
      id: 'palette1',
      title: 'Group Shapes',
      symbols: getSymbols(),
      expanded: true,
    },
  ],
  height: 500,
  width: '30%',
});

palette.appendTo('#palette');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="palette" style="float: left">
        </div>
        <div id="element" style="float: right"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Update group node at runtime

Group can be updated dynamically similar to the normal nodes. The following code illustrates how to update group node at runtime.

var nodes = [
  {
    id: 'rectangle1',
    offsetX: 100,
    offsetY: 100,
    width: 100,
    height: 100,
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
    },
    annotations: [
      {
        content: 'rectangle1',
      },
    ],
  },
  {
    id: 'rectangle2',
    offsetX: 200,
    offsetY: 200,
    width: 100,
    height: 100,
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
    },
    annotations: [
      {
        content: 'rectangle2',
      },
    ],
  },
  {
    id: 'group',
    children: ['rectangle1', 'rectangle2'],
    style: { strokeColor: 'green' },
  },
];

var diagram = new ej.diagrams.Diagram(
  {
    width: '1500px',
    height: '600px',
    nodes: nodes,
  },
  '#element'
);

document.getElementById('updateGroupPadding').onclick = () => {
    let group = diagram.nameTable['group'];
    (group.padding = { left: 10, right: 10, top: 10, bottom: 10 }), group.style;
    diagram.dataBind();
  };
  
  document.getElementById('updateGroupStyle').onclick = () => {
    let group = diagram.nameTable['group'];
    group.style = { fill: 'yellow' };
    diagram.dataBind();
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="updateGroupPadding" id="updateGroupPadding" />
        <input type="button" value="updateGroupStyle" id="updateGroupStyle" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Container

Containers are used to automatically measure and arrange the size and position of the child elements in a predefined manner. There are two types of containers available.

Canvas

  • The canvas panel supports absolute positioning and provides the least layout functionality to its contained diagram elements.

  • Canvas allows you to position its contained elements by using the margin and alignment properties.

  • Rendering alone possible in canvas container.

  • It allows elements to be either vertically or horizontally aligned.

  • Child can be defined with the collection canvas.children property.

  • Basic element can be defined with the collection of basicElements.

The following code illustrates how to add canvas panel.

var diagram;
var canvas;
var child1;
var child2;
canvas = new ej.diagrams.Canvas();
canvas.pivot = {
  x: 0,
  y: 0,
};
canvas.offsetX = 200;
canvas.offsetY = 100;
canvas.style.fill = '#6BA5D7';
child1 = new ej.diagrams.DiagramElement();
(child1.id = 'child1'), (child1.width = 100);
child1.height = 100;
child1.margin.left = child1.margin.top = 10;
child2 = new ej.diagrams.DiagramElement();
(child2.id = 'child2'), (child2.width = 100);
child2.height = 100;
child2.margin.left = 190;
child2.margin.top = 170;
child2.margin.bottom = 5;
child2.margin.right = 5;
canvas.children = [child1, child2];
diagram = new ej.diagrams.Diagram(
  {
    mode: 'SVG',
    width: '1000px',
    height: '600px',
    basicElements: [canvas],
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Stack

  • Stack panel is used to arrange its children in a single line or stack order, either vertically or horizontally.

  • It controls spacing by setting margin properties of child and padding properties of group. By default, a stack panel’s orientation is vertical.

The following code illustrates how to add a stack panel.

var diagram;
var nodes = [{
    id: "node5",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    style: {
      strokeColor: "#6BA5D7",
      fill: "#6BA5D7"
    },
    annotations: [{
        content: "Custom Template",
        offset: {
          y: 1
        },
        verticalAlignment: "Top"
      }]
  }];
var count = 11;
var getTextElement = function(text) {
  var textElement = new ej.diagrams.TextElement();
  textElement.id = "text" + count;
  textElement.width = 50;
  textElement.height = 20;
  textElement.content = text;
  count++;
  return textElement;
};
var addRows = function(column) {
  column.children.push(getTextElement("Row1"));
  column.children.push(getTextElement("Row2"));
  column.children.push(getTextElement("Row3"));
  column.children.push(getTextElement("Row4"));
};

//Initializes diagram control
diagram = new ej.diagrams.Diagram({
  width: 900,
  height: 900,
  nodes: nodes,
  setNodeTemplate: function(obj, diagram) {
    if (obj.id.indexOf("node5") !== -1) {
      var table = new ej.diagrams.StackPanel();
      table.orientation = "Horizontal";
      var column1 = new ej.diagrams.StackPanel();
      column1.children = [];
      column1.children.push(getTextElement("Column1"));
      addRows(column1);
      var column2 = new ej.diagrams.StackPanel();
      column2.children = [];
      column2.children.push(getTextElement("Column2"));
      addRows(column2);
      table.children = [column1, column2];
      return table;
    }
    return null;
    },
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Difference between a basic group and containers

Group Container
It arranges the child elements based on the child elements position and size properties. Each container has a predefined behavior to measure and arrange its child elements. Canvas and stack containers are supported in the diagram.
The Min, and Max Size properties are not applicable for basic group. It is applicable for container.
The Children’s margin and alignment properties are not applicable for basic group. It is applicable for container.

Interaction

Group node interactions can be performed similarly to normal nodes. Fundamental diagram interactions like selecting, dragging, resizing, and rotating apply equally to group nodes. For more informatation refer to the nodes interactions

Selecting a Node Group

When a child element within a node group is clicked, the entire contained node group is selected instead of the individual child element. Subsequent clicks on the selected element change the selection from top to bottom within the hierarchy, moving from the parent node group to its children.

Group Interactions GIF

Events

The events triggered when interacting with group nodes are similar to those for individual nodes. For more information, refer to the nodes events

See Also

Syncfusion AI Assistant

How can I help you?

Group in Vue Diagram component

16 May 202624 minutes to read

Create group

Group is used to cluster multiple nodes and connectors into a single element. It acts like a container for its children (nodes, groups, and connectors). Every change made to the group also affects the children. Child elements can be edited individually.

Add group when initializing diagram

A group can be added to the diagram model through nodes collection. To define an object as group, add the child objects to the children collection of the group. The following code illustrates how to create a group node.

  • While creating group, its child node need to be declared before the group declaration.
<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :getNodeDefaults="getNodeDefaults"
            :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: "rectangle1",
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: "#6BA5D7",
            fill: "#6BA5D7",
        },
        annotations: [
            {
                content: "rectangle1",
            },
        ],
    },
    {
        id: "rectangle2",
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: "#6BA5D7",
            fill: "#6BA5D7",
        },
        annotations: [
            {
                content: "rectangle2",
            },
        ],
    },
    {
        id: "group",
        children: ["rectangle1", "rectangle2"],
    },
];

function getNodeDefaults(node) {
    node.height = 100;
    node.width = 100;
    node.style.strokeColor = "White";
    return node;
}

const diagramRef = ref(null);

onMounted(() => {
    // Retrieve the diagram instance
    const diagramInstance = diagramRef.value.ej2Instances;
    diagramInstance.select([diagramInstance.getObject("group")]);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :getNodeDefaults="getNodeDefaults"
      :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: "rectangle1",
          offsetX: 100,
          offsetY: 100,
          width: 100,
          height: 100,
          style: {
            strokeColor: "#6BA5D7",
            fill: "#6BA5D7",
          },
          annotations: [
            {
              content: "rectangle1",
            },
          ],
        },
        {
          id: "rectangle2",
          offsetX: 200,
          offsetY: 200,
          width: 100,
          height: 100,
          style: {
            strokeColor: "#6BA5D7",
            fill: "#6BA5D7",
          },
          annotations: [
            {
              content: "rectangle2",
            },
          ],
        },
        {
          id: "group",
          children: ["rectangle1", "rectangle2"],
        },
      ],
    };
  },
  methods: {
    getNodeDefaults(node) {
      node.height = 100;
      node.width = 100;
      node.style.strokeColor = "White";
      return node;
    },
  },
  mounted() {
    // Retrieve the diagram instance
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.select([diagramInstance.getObject("group")]);
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Connectors can be added to a group. The following code illustrates how to add connectors into a group.

<template>
    <div id="app">
        <ejs-diagram id="diagram" width="1000px" height="600px" :nodes="nodes" :connectors="connectors" />
    </div>
</template>

<script setup>
import { ref } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const connectors = ref([
    {
        id: "connector1",
        type: "Orthogonal",
        sourceID: "node1",
        targetID: "node2",
    },
]);

const nodes = ref([
    {
        id: "node1",
        height: 100,
        width: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: "Node1" }],
    },
    {
        id: "node2",
        height: 100,
        width: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: "Node2" }],
    },
    // Defining group having connector children
    {
        id: "group",
        children: ["node1", "node2", "connector1"],
        style: { strokeWidth: 0 },
    },
]);
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram id="diagram" width="1000px" height="600px" :nodes="nodes" :connectors="connectors" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      connectors: [
        {
          id: "connector1",
          type: "Orthogonal",
          sourceID: "node1",
          targetID: "node2",
        },
      ],
      nodes: [
        {
          id: "node1",
          height: 100,
          width: 100,
          offsetX: 100,
          offsetY: 100,
          annotations: [{ content: "Node1" }],
        },
        {
          id: "node2",
          height: 100,
          width: 100,
          offsetX: 300,
          offsetY: 100,
          annotations: [{ content: "Node2" }],
        },
        // Defining group having connector children
        {
          id: "group",
          children: ["node1", "node2", "connector1"],
          style: { strokeWidth: 0 },
        },
      ],
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Group nodes at runtime

Groups can be dynamically created during runtime in the diagram by invoking the diagram.group method. To initiate this process, first, select the nodes that you intend to include within the group. Subsequently, by utilizing the diagram.group method, the selected nodes will be encapsulated within a newly formed group node.

The following code illustrates how to group at runtime.

<template>
    <div id="app">
        <button @click="group">Group selected nodes</button>
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="900px" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: "node1",
        height: 100,
        width: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: "Node1" }],
    },
    {
        id: "node2",
        height: 100,
        width: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: "Node2" }],
    },
    {
        id: "node3",
        height: 100,
        width: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: "Node3" }],
    },
];
const diagramRef = ref(null);
onMounted(() => {
    const diagram = diagramRef.value.ej2Instances;
    diagram.selectAll();
});
function group() {
    // Groups the selected nodes in diagram
    const diagram = diagramRef.value.ej2Instances;
    diagram.group();
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <button @click="group">Group selected nodes</button>
    <ejs-diagram ref="diagram" id="diagram" width="100%" height="900px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: "node1",
          height: 100,
          width: 100,
          offsetX: 100,
          offsetY: 100,
          annotations: [{ content: "Node1" }],
        },
        {
          id: "node2",
          height: 100,
          width: 100,
          offsetX: 200,
          offsetY: 200,
          annotations: [{ content: "Node2" }],
        },
        {
          id: "node3",
          height: 100,
          width: 100,
          offsetX: 300,
          offsetY: 300,
          annotations: [{ content: "Node3" }],
        },
      ],
    };
  },
  mounted() {
    const diagram = this.$refs.diagram.ej2Instances;
    diagram.selectAll();
  },
  methods: {
    group() {
      const diagram = this.$refs.diagram.ej2Instances;
      // Groups the selected nodes in diagram
      diagram.group();
    },
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

UnGroup nodes at runtime

Group node can be ungrouped dynamically, by using the diagram.unGroup method. The following code example shows how to ungroup a group node at runtime.

<template>
    <div id="app">
        <button @click="unGroup">Ungroup</button>
        <ejs-diagram ref="diagramRef" id="diagram" :width="'100%'" :height="'600px'" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const diagramRef = ref(null);
const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [
            {
                content: 'rectangle1',
            },
        ],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [
            {
                content: 'rectangle2',
            },
        ],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    },
];
onMounted(() => {
    const diagramInstance = diagramRef.value.ej2Instances;
    diagramInstance.select([diagramInstance.getObject('group')]);
});
const unGroup = () => {
    const diagramInstance = diagramRef.value.ej2Instances;
    // Ungroups the selected nodes and connectors in the diagram
    diagramInstance.unGroup();
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <button @click="unGroup">Ungroup</button>
    <ejs-diagram ref="diagramRef" id="diagram" :width="'100%'" :height="'600px'" :nodes="nodes">
    </ejs-diagram>
  </div>
</template>

<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: 'rectangle1',
          offsetX: 100,
          offsetY: 100,
          width: 100,
          height: 100,
          style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
          },
          annotations: [
            {
              content: 'rectangle1',
            },
          ],
        },
        {
          id: 'rectangle2',
          offsetX: 200,
          offsetY: 200,
          width: 100,
          height: 100,
          style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
          },
          annotations: [
            {
              content: 'rectangle2',
            },
          ],
        },
        {
          id: 'group',
          children: ['rectangle1', 'rectangle2'],
        },
      ],
    };
  },
  mounted() {
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.select([diagramInstance.getObject('group')]);
  },
  methods: {
    unGroup() {
      const diagramInstance = this.$refs.diagramRef.ej2Instances;
      // Ungroups the selected nodes and connectors in the diagram
      diagramInstance.unGroup();
    },
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Add group node at runtime

A group node can be added at runtime by using the diagram method diagram.add.

The following code illustrates how a group node is added at runtime.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" :width="'100%'" :height="'350px'" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = ref([
    {
        id: "rectangle1",
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{ content: 'rectangle1' }],
    },
    {
        id: "rectangle2",
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{ content: 'rectangle2' }],
    },
]);

const group = {
    id: 'group2',
    children: ['rectangle1', 'rectangle2'],
};

const diagramRef = ref(null);

onMounted(() => {
    const diagramInstance = diagramRef.value.ej2Instances;
    diagramInstance.selectAll();
    // Add the group into the diagram
    diagramInstance.add(group);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramRef" :width='width' :height='height' :nodes='nodes'>
        </ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: "rectangle1",
    offsetX: 100,
    offsetY: 100,
    width: 100,
    height: 100,
    style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
    },
    annotations: [{
        content: 'rectangle1'
    }]
},
{
    id: "rectangle2",
    offsetX: 200,
    offsetY: 200,
    width: 100,
    height: 100,
    style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
    },
    annotations: [{
        content: 'rectangle2'
    }]
}];
let group = {
    id: 'group2',
    children: ['rectangle1', 'rectangle2']
};
export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    },
    mounted: function () {
        const diagramInstance = this.$refs.diagramRef.ej2Instances;
        diagramInstance.selectAll();
        // Add the group into the diagram
        diagramInstance.add(group);
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Add collection of group nodes at runtime

  • The collection of group nodes can be dynamically added using addElements method.Each time an element is added to the diagram canvas, the collectionChange event will be triggered.

The following code illustrates how to add group nodes collection at runtime.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="580px" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from "@syncfusion/ej2-vue-diagrams";

const diagramRef = ref(null);

const group = [
    { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: "node1" }] },
    { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: "node2" }] },
    { id: "group", children: ["rectangle1", "rectangle2"] },
    { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: "node1" }] },
    { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: "node2" }] },
    { id: "group2", children: ["rectangle3", "rectangle4"], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
];

onMounted(() => {
    const diagram = diagramRef.value.ej2Instances;
    // Add the group collection into the diagram
    diagram.addElements(group);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="580px" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
const group = [
  { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: "node1" }] },
  { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: "node2" }] },
  { id: "group", children: ["rectangle1", "rectangle2"] },
  { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: "node1" }] },
  { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: "node2" }] },
  { id: "group2", children: ["rectangle3", "rectangle4"], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
];
export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {

    };
  },
  mounted() {
    const diagram = this.$refs.diagramRef.ej2Instances;
    // Add the group collection into the diagram
    diagram.addElements(group);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Add/Remove children from group

Add children To group at runtime

A childNode can be added to the specified Group at runtime by utilizing the diagram method diagram.addChildToGroup.

This functionality is achieved by passing the group and existing children as arguments to the method.

The following code illustrates how a child node and a group node can be passed as arguments to the method and executed at runtime.

diagramInstance.addChildToGroup(groupNode, childNode);

Remove children from group at runtime

A specific child from a group node can be removed at runtime by utilizing the diagram method diagram.removeChildFromGroup.

This functionality is achieved by passing the group and its children as arguments to the method.

The following code illustrates how a child node is removed from a group at runtime.

diagramInstance.removeChildFromGroup (groupNode, childNode);
<template>
    <div id="app">
        <button @click="addChild">Add Child to Group</button>
        <button @click="removeChild">Remove Child from Group</button>
        <ejs-diagram ref="diagramRef" id="diagram" :width="'100%'" :height="'600px'" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from "@syncfusion/ej2-vue-diagrams";

const nodes = ref([
    { id: "node1", width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: "Node1" }] },
    { id: "node2", width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: "Node2" }] },
    { id: "group1", children: ["node1", "node2"] },
    { id: "node3", width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: "Node3" }] },
]);

const diagramRef = ref(null);
let diagramInstance = null;

onMounted(() => {
    diagramInstance = diagramRef.value.ej2Instances;
    diagramInstance.select([diagramInstance.getObject('group1')]);
});

const addChild = () => {
    // Adds the specified diagram object to the specified group node.
    /**
      * parameter 1 - The group node to which the diagram object will be added.
      * parameter 2 - The diagram object to be added to the group.
      */
    diagramInstance.addChildToGroup(diagramInstance.getObject("group1"), "node3");
};

const removeChild = () => {
    // Removes the specified diagram object from the specified group node.
    /**
      * parameter 1 - The group node from which the diagram object will be removed.
      * parameter 2 - The diagram object to be removed from the group.
      */
    diagramInstance.removeChildFromGroup(diagramInstance.getObject("group1"), "node3");
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <button @click="addChild">Add Child to Group</button>
    <button @click="removeChild">Remove Child from Group</button>
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
let diagramInstance;
export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        { id: "node1", width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: "Node1" }] },
        { id: "node2", width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: "Node2" }] },
        { id: "group1", children: ["node1", "node2"] },
        { id: "node3", width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: "Node3" }] },
      ],
    };
  },
  mounted() {
    diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.select([diagramInstance.getObject('group1')]);
  },
  methods: {
    addChild() {
      // Adds the specified diagram object to the specified group node.
      /**
        * parameter 1 - The group node to which the diagram object will be added.
        * parameter 2 - The diagram object to be added to the group.
        */
      diagramInstance.addChildToGroup(diagramInstance.getObject("group1"), "node3");
    },
    removeChild() {
      // Removes the specified diagram object from the specified group node.
      /**
        * parameter 1 - The group node from which the diagram object will be removed.
        * parameter 2 - The diagram object to be removed from the group.
        */
      diagramInstance.removeChildFromGroup(diagramInstance.getObject("group1"), "node3");
    },
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Group padding

The Padding property of a group node defines the spacing between the group node’s edges and its children.

The following code illustrates how to add Padding to the node group.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: "node1",
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: "Node1" }],
    },
    {
        id: "node2",
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: "Node2" }],
    },
    {
        id: "node3",
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: "Node3" }],
    },
    {
        id: "group",
        children: ["node1", "node2", "node3"],
        // Defines the space between the group node edges and its children
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
    },
];

const diagramRef = ref(null);

onMounted(() => {
    // Access the diagram instance and select the group node once the diagram is mounted
    const diagram = diagramRef.value.ej2Instances;
    diagram.select([diagram.getObject("group")]);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagram" id="diagram" width="100%" height="600px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: "node1",
          width: 100,
          height: 100,
          offsetX: 100,
          offsetY: 100,
          annotations: [{ content: "Node1" }],
        },
        {
          id: "node2",
          width: 100,
          height: 100,
          offsetX: 200,
          offsetY: 200,
          annotations: [{ content: "Node2" }],
        },
        {
          id: "node3",
          width: 100,
          height: 100,
          offsetX: 300,
          offsetY: 300,
          annotations: [{ content: "Node3" }],
        },
        {
          id: "group",
          children: ["node1", "node2", "node3"],
          // Defines the space between the group node edges and its children
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
        },
      ],
    };
  },
  mounted() {
    const diagram = this.$refs.diagram.ej2Instances;
    diagram.select([diagram.getObject("group")]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Group flip

The flip functionality for a group node works similarly to that of normal nodes. However, when flipping a group node, the flip of its child nodes is combined with the group’s flip. This combination ensures that the child nodes inherit the group’s flip while retaining their own individual flips.

Example:

  • If a child node’s flip is set to Vertical and the group node’s flip is set to Horizontal, the resulting flip for the child node will be a combination of Vertical and Horizontal (effectively a “both” flip).
  • This ensures that the child nodes’ orientations adapt dynamically based on the group’s flip while maintaining their unique flip settings.

The following example shows how to apply flip for group node.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram, FlipDirection } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip as Vertical
        flip: FlipDirection.Vertical,
        shape: {
            type: 'Basic',
            shape: 'RightTriangle',
        },
        style: {
            fill: '#6BA5D7',
        },
    },
    {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
            type: 'Basic',
            shape: 'RightTriangle',
        },
        style: {
            fill: '#6BA5D7',
        },

    },
    {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
    }
];

const diagramRef = ref(null);

onMounted(() => {
    // Access the diagram instance and select the group node once the diagram is mounted
    const diagram = diagramRef.value.ej2Instances;
    diagram.select([diagram.getObject("group")]);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagram" id="diagram" width="100%" height="600px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent, FlipDirection } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: 'node1',
          width: 70,
          height: 70,
          offsetX: 100,
          offsetY: 100,
          //Sets the flip as Vertical
          flip: FlipDirection.Vertical,
          shape: {
            type: 'Basic',
            shape: 'RightTriangle',
          },
          style: {
            fill: '#6BA5D7',
          },
        },
        {
          id: 'node2',
          width: 70,
          height: 70,
          offsetX: 180,
          offsetY: 180,
          shape: {
            type: 'Basic',
            shape: 'RightTriangle',
          },
          style: {
            fill: '#6BA5D7',
          },

        },
        {
          id: 'group',
          children: ['node1', 'node2',],
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
          //Sets the flip as Horizontal
          flip: FlipDirection.Horizontal,
        }
      ],
    };
  },
  mounted() {
    const diagram = this.$refs.diagram.ej2Instances;
    diagram.select([diagram.getObject("group")]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Group flip mode

The flipMode of a group node also behave similarly to those of normal nodes. However,When you apply a flip mode to a group node, it takes precedence over any flip mode set on its child nodes, overriding their individual settings.

For example, in the below code,
the flipMode for the child node Node1 is set to LabelText.
The flipMode for the group node is set to Label.
As a result, the effective flipMode for both the child node and the group node will be Label, as the group node’s flipMode overrides the child’s.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram, FlipDirection } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip mode as LabelText
        flipMode: 'LabelText',
        annotations: [{ content: 'Node1', offset: { x: 0, y: 0.8 } }],
        shape: {
            type: 'Basic',
            shape: 'RightTriangle',
        },
        style: {
            fill: '#6BA5D7',
        },
    },
    {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
            type: 'Basic',
            shape: 'RightTriangle',
        },
        style: {
            fill: '#6BA5D7',
        },

    },
    {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        annotations: [{ content: 'Group', offset: { x: 0, y: 0.8 } }],
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
        //Sets the flip mode as Label
        flipMode: 'Label',
    }
];

const diagramRef = ref(null);

onMounted(() => {
    // Access the diagram instance and select the group node once the diagram is mounted
    const diagram = diagramRef.value.ej2Instances;
    diagram.select([diagram.getObject("group")]);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagram" id="diagram" width="100%" height="600px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent, FlipDirection } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: 'node1',
          width: 70,
          height: 70,
          offsetX: 100,
          offsetY: 100,
          //Sets the flip mode as LabelText
          flipMode: 'LabelText',
          annotations: [{ content: 'Node1', offset: { x: 0, y: 0.8 } }],
          shape: {
            type: 'Basic',
            shape: 'RightTriangle',
          },
          style: {
            fill: '#6BA5D7',
          },
        },
        {
          id: 'node2',
          width: 70,
          height: 70,
          offsetX: 180,
          offsetY: 180,
          shape: {
            type: 'Basic',
            shape: 'RightTriangle',
          },
          style: {
            fill: '#6BA5D7',
          },

        },
        {
          id: 'group',
          children: ['node1', 'node2',],
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
          annotations: [{ content: 'Group', offset: { x: 0, y: 0.8 } }],
          //Sets the flip as Horizontal
          flip: FlipDirection.Horizontal,
          //Sets the flip mode as Label
          flipMode: 'Label',
        }
      ],
    };
  },
  mounted() {
    const diagram = this.$refs.diagram.ej2Instances;
    diagram.select([diagram.getObject("group")]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Nested group

Nested groups are essentially groups within groups, where a group can contain other groups as its children, creating a hierarchy that helps manage complexity and relationships between different elements.

Nested Group GIF

The following code illustrates how to create nested group node.

<template>
    <div id="app">
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = ref([
    {
        id: "node1",
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: "Node1" }],
    },
    {
        id: "node2",
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: "Node2" }],
    },
    {
        id: "node3",
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 350,
        annotations: [{ content: "Node3" }],
    },
    {
        id: "node4",
        width: 100,
        height: 100,
        offsetX: 500,
        offsetY: 350,
        annotations: [{ content: "Node4" }],
    },
    {
        id: "group1",
        children: ["node1", "node2"],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: "green" },
    },
    {
        id: "group2",
        children: ["node3", "node4"],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: "skyblue" },
    },
    // Nested Group
    {
        id: "group3",
        children: ["group1", "group2"],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: "yellow" },
    },
]);

const diagramRef = ref(null);

onMounted(() => {
    const diagramInstance = diagramRef.value.ej2Instances;
    diagramInstance.select([diagramInstance.getObject("group3")]);
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: "node1",
          width: 100,
          height: 100,
          offsetX: 100,
          offsetY: 100,
          annotations: [{ content: "Node1" }],
        },
        {
          id: "node2",
          width: 100,
          height: 100,
          offsetX: 200,
          offsetY: 200,
          annotations: [{ content: "Node2" }],
        },
        {
          id: "node3",
          width: 100,
          height: 100,
          offsetX: 300,
          offsetY: 350,
          annotations: [{ content: "Node3" }],
        },
        {
          id: "node4",
          width: 100,
          height: 100,
          offsetX: 500,
          offsetY: 350,
          annotations: [{ content: "Node4" }],
        },
        {
          id: "group1",
          children: ["node1", "node2"],
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
          style: { fill: "green" },
        },
        {
          id: "group2",
          children: ["node3", "node4"],
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
          style: { fill: "skyblue" },
        },
        // Nested Group
        {
          id: "group3",
          children: ["group1", "group2"],
          padding: { left: 20, right: 20, top: 20, bottom: 20 },
          style: { fill: "yellow" },
        },
      ],
    };
  },
  mounted() {
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.select([diagramInstance.getObject("group3")]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Add Group in palette

Group node can be added in symbol palette like the normal nodes. The following code illustrates how to render group node in palette.

<template>
    <div id="app">
        <ejs-symbolpalette ref="symbolPalette" id="symbolpalette" :expandMode="expandMode" width="20%"
            :palettes="palettes"></ejs-symbolpalette>
        <ejs-diagram ref="diagramRef" id="diagram" width="80%" height="645px" :nodes="nodes"
            @created="onCreated"></ejs-diagram>
    </div>
</template>

<script setup>
import { ref } from 'vue';
import { DiagramComponent as EjsDiagram, SymbolPaletteComponent as EjsSymbolpalette } from '@syncfusion/ej2-vue-diagrams';

const expandMode = ref("Multiple");
const nodes = ref([
    {
        offsetX: 250,
        offsetY: 250,
        width: 100,
        height: 100,
        visible: true,
        style: { fill: "#6AA8D7", strokeWidth: 1 },
    },
]);

const palettes = ref([
    {
        id: "palette1",
        title: "Basic Shapes",
        symbols: getSymbols(),
        expanded: true,
    },
]);

function getSymbols() {
    return [
        {
            id: "n1",
            height: 50,
            width: 50,
            offsetX: 50,
            offsetY: 50,
            style: { fill: "green" },
        },
        {
            id: "n2",
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: "yellow" },
        },
        {
            id: "group1",
            children: ["n1", "n2"],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
        {
            id: "n3",
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: "pink" },
        },
        {
            id: "n4",
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 170,
            style: { fill: "orange" },
        },
        {
            id: "group2",
            children: ["n3", "n4"],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
    ];
}

const diagramRef = ref(null);

function onCreated() {
    const diagram = diagramRef.value.ej2Instances;
    diagram.fitToPage({ mode: "Width" });
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-symbolpalette ref="symbolPalette" id="symbolpalette" :expandMode="expandMode" width="20%" :palettes="palettes">
    </ejs-symbolpalette>
    <ejs-diagram ref="diagram" id="diagram" width="80%" height="645px" :nodes="nodes" @created="onCreated">
    </ejs-diagram>
  </div>
</template>

<script>
import { DiagramComponent, SymbolPaletteComponent } from "@syncfusion/ej2-vue-diagrams";

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
    "ejs-symbolpalette": SymbolPaletteComponent,
  },
  data() {
    return {
      expandMode: "Multiple",
      nodes: [
        {
          offsetX: 250,
          offsetY: 250,
          width: 100,
          height: 100,
          visible: true,
          style: { fill: "#6AA8D7", strokeWidth: 1 },
        },
      ],
      palettes: [
        {
          id: "palette1",
          title: "Basic Shapes",
          symbols: this.getSymbols(),
          expanded: true,
        },
      ],
    };
  },
  methods: {
    getSymbols() {
      return [
        {
          id: "n1",
          height: 50,
          width: 50,
          offsetX: 50,
          offsetY: 50,
          style: { fill: "green" },
        },
        {
          id: "n2",
          height: 50,
          width: 50,
          offsetX: 100,
          offsetY: 100,
          style: { fill: "yellow" },
        },
        {
          id: "group1",
          children: ["n1", "n2"],
          padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
        {
          id: "n3",
          height: 50,
          width: 50,
          offsetX: 100,
          offsetY: 100,
          style: { fill: "pink" },
        },
        {
          id: "n4",
          height: 50,
          width: 50,
          offsetX: 100,
          offsetY: 170,
          style: { fill: "orange" },
        },
        {
          id: "group2",
          children: ["n3", "n4"],
          padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
      ];
    },
    onCreated() {
      const diagram = this.$refs.diagram.ej2Instances;
      diagram.fitToPage({ mode: "Width" });
    },
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Update group node at runtime

Group can be updated dynamically similar to the normal nodes. The following code illustrates how to update group node at runtime.

<template>
    <div id="app">
        <button @click="updatePadding">Update Group Padding</button>
        <button @click="updateStyle">Update Group Style</button>
        <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :nodes="nodes" />
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: { strokeColor: '#6BA5D7', fill: '#6BA5D7' },
        annotations: [{ content: 'rectangle1' }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: { strokeColor: '#6BA5D7', fill: '#6BA5D7' },
        annotations: [{ content: 'rectangle2' }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
        style: { strokeColor: 'green' },
    },
];

const diagramRef = ref(null);
let diagramInstance;
function updatePadding() {
    const group = diagramInstance.getObject('group');
    group.padding = { left: 10, right: 10, top: 10, bottom: 10 };
    diagramInstance.dataBind();
}

function updateStyle() {
    const group = diagramInstance.getObject('group');
    group.style = { fill: 'green' };
    diagramInstance.dataBind();
}

onMounted(() => {
    diagramInstance = diagramRef.value.ej2Instances;
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <button @click="updatePadding">Update Group Padding</button>
    <button @click="updateStyle">Update Group Style</button>
    <ejs-diagram ref="diagram" id="diagram" width="100%" height="600px" :nodes="nodes">
    </ejs-diagram>
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
let diagramInstance;
export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      nodes: [
        {
          id: 'rectangle1',
          offsetX: 100,
          offsetY: 100,
          width: 100,
          height: 100,
          style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
          },
          annotations: [
            {
              content: 'rectangle1',
            },
          ],
        },
        {
          id: 'rectangle2',
          offsetX: 200,
          offsetY: 200,
          width: 100,
          height: 100,
          style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
          },
          annotations: [
            {
              content: 'rectangle2',
            },
          ],
        },
        {
          id: 'group',
          children: ['rectangle1', 'rectangle2'],
          style: { strokeColor: 'green' },
        },
      ],
    };
  },
  mounted() {
    diagramInstance = this.$refs.diagram.ej2Instances;
  },
  methods: {
    updatePadding() {
      let group = diagramInstance.getObject('group');
      group.padding = { left: 10, right: 10, top: 10, bottom: 10 };
      this.diagramInstance.dataBind();
    },
    updateStyle() {
      let group = diagramInstance.getObject('group');
      group.style = { fill: 'green' };
      this.diagramInstance.dataBind();
    },
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Container

Containers are used to automatically measure and arrange the size and position of the child elements in a predefined manner. There are two types of containers available.

Canvas

  • The canvas panel supports absolute positioning and provides the least layout functionality to its contained diagram elements.

  • Canvas allows you to position its contained elements by using the margin and alignment properties.

  • Rendering alone possible in canvas container.

  • It allows elements to be either vertically or horizontally aligned.

  • Child can be defined with the collection canvas.children property.

  • Basic element can be defined with the collection of basicElements.

Stack

  • Stack panel is used to arrange its children in a single line or stack order, either vertically or horizontally.

  • It controls spacing by setting margin properties of child and padding properties of group. By default, a stack panel’s orientation is vertical.

The following code illustrates how to add a stack panel.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width="width" :height="height" :nodes="nodes" :getNodeDefaults="getNodeDefaults"
            :setNodeTemplate="setNodeTemplate" />
    </div>
</template>

<script setup>
import {
    DiagramComponent as EjsDiagram,
    StackPanel,
    TextElement,
    randomId
} from '@syncfusion/ej2-vue-diagrams';

const width = "100%";
const height = "350px";

const nodes = [
    {
        id: 'stacknode',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7'
        },
        annotations: [
            {
                content: 'Custom Template',
                offset: { y: 1 },
                verticalAlignment: 'Top'
            }
        ]
    }
];

const getNodeDefaults = (node) => {
    node.height = 100;
    node.width = 100;
    node.style.fill = '#6BA5D7';
    node.style.strokeColor = 'white';
    return node;
};

const createTextElement = (text) => {
    const textElement = new TextElement();
    textElement.id = "text" + randomId();
    textElement.width = 50;
    textElement.height = 20;
    textElement.content = text;
    return textElement;
};

const addTextRows = (stackPanel) => {
    const rows = ['Row1', 'Row2', 'Row3', 'Row4'];
    rows.forEach(row => stackPanel.children.push(createTextElement(row)));
};

const setNodeTemplate = (obj) => {
    if (obj && obj.id.includes('stacknode')) {
        // Create the stack panel for the node template
        const table = new StackPanel();
        table.orientation = 'Horizontal';

        // Initialize column1 and add elements
        const column1 = new StackPanel();
        column1.children = [];
        column1.children.push(createTextElement('Column1'));
        addTextRows(column1);

        // Initialize column2 and add elements
        const column2 = new StackPanel();
        column2.children = [];
        column2.children.push(createTextElement('Column2'));
        addTextRows(column2);

        table.children = [column1, column2];
        return table;
    }
    return null;
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram id="diagram" :width="width" :height="height" :nodes="nodes" :getNodeDefaults="getNodeDefaults"
      :setNodeTemplate="setNodeTemplate">
    </ejs-diagram>
  </div>
</template>

<script>
import { DiagramComponent, StackPanel, TextElement, randomId } from '@syncfusion/ej2-vue-diagrams';

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: [
        {
          id: 'stacknode',
          width: 100,
          height: 100,
          offsetX: 100,
          offsetY: 100,
          style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7'
          },
          annotations: [
            {
              content: 'Custom Template',
              offset: { y: 1 },
              verticalAlignment: 'Top'
            }
          ]
        }
      ],
      getNodeDefaults: (node) => {
        node.height = 100;
        node.width = 100;
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
      },
      setNodeTemplate: (obj) => {
        if (obj && obj.id.includes('stacknode')) {
          // Create the stack panel for the node template
          const table = new StackPanel();
          table.orientation = 'Horizontal';

          // Initialize column1 and add elements
          const column1 = new StackPanel();
          column1.children = [];
          column1.children.push(this.createTextElement('Column1'));
          this.addTextRows(column1);

          // Initialize column2 and add elements
          const column2 = new StackPanel();
          column2.children = [];
          column2.children.push(this.createTextElement('Column2'));
          this.addTextRows(column2);

          table.children = [column1, column2];
          return table;
        }
        return null;
      }
    }
  },
  methods: {
    createTextElement(text) {
      const textElement = new TextElement();
      textElement.id = "text" + randomId();
      textElement.width = 50;
      textElement.height = 20;
      textElement.content = text;
      return textElement;
    },
    addTextRows(stackPanel) {
      const rows = ['Row1', 'Row2', 'Row3', 'Row4'];
      rows.forEach(row => stackPanel.children.push(this.createTextElement(row)));
    }
  }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Difference between a basic group and containers

Group Container
It arranges the child elements based on the child elements position and size properties. Each container has a predefined behavior to measure and arrange its child elements. Canvas and stack containers are supported in the diagram.
The Padding, Min, and Max Size properties are not applicable for basic group. It is applicable for container.
The Children’s margin and alignment properties are not applicable for basic group. It is applicable for container.

Interaction

Group node interactions can be performed similarly to normal nodes. Fundamental diagram interactions like selecting, dragging, resizing, and rotating apply equally to group nodes. For more informatation refer to the nodes interactions

Selecting a Node Group

When a child element within a node group is clicked, the entire contained node group is selected instead of the individual child element. Subsequent clicks on the selected element change the selection from top to bottom within the hierarchy, moving from the parent node group to its children.

Group Interactions GIF

Events

The events triggered when interacting with group nodes are similar to those for individual nodes. For more information, refer to the nodes events

See Also

Syncfusion AI Assistant

How can I help you?

Group in Angular Diagram Component

17 Mar 202624 minutes to read

Groups enable developers to cluster multiple nodes and connectors into a single manageable element, acting as a container that maintains relationships between child elements while allowing both collective and individual manipulation. This powerful feature streamlines complex diagram management by treating related elements as cohesive units while preserving the ability to edit individual components when needed.

Create group

A group functions as a container for its children (nodes, groups, and connectors). Every change made to the group affects all children proportionally, while child elements remain individually editable. Groups can contain other groups, creating nested hierarchies for complex diagram structures.

Add group when initializing diagram

A group can be added to the diagram model through the nodes collection. To define an object as a group, add the child objects to the children collection of the group. The following code illustrates how to create a group node.

Important: When creating a group, child nodes must be declared before the group declaration.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser'
import { DiagramModule } from '@syncfusion/ej2-angular-diagrams'
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [getNodeDefaults] ='getNodeDefaults' [nodes]='nodes' (created)='created($event)'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'rectangle1',
      offsetX: 100,
      offsetY: 100,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle1',
        },
      ],
    },
    {
      id: 'rectangle2',
      offsetX: 200,
      offsetY: 200,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle2',
        },
      ],
    },
    {
      id: 'group',
      children: ['rectangle1', 'rectangle2'],
    },
  ];
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    ((node as NodeModel).style as ShapeStyleModel).strokeColor = "White";
    return node;
  }
  public created(args: Object): void {
    (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).getObject('group')]);
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Connectors can also be added to a group. To create a group using nodes and connectors in the Angular Diagram, refer to the below video link:

The following code illustrates how to add connectors into a group:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DiagramModule } from '@syncfusion/ej2-angular-diagrams'

import { Component, ViewEncapsulation, ViewChild, } from '@angular/core';
import {
  DiagramComponent, NodeModel, ConnectorModel,
} from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="1000px" height="700px" [nodes]='nodes' [connectors]="connectors">
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public connectors: ConnectorModel[] = [{
    id: 'connector1', type: 'Orthogonal', sourceID: 'node1', targetID: 'node2'
  },
  ];
  public nodes: NodeModel[] = [{
    id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
  },
  {
    id: 'node2', height: 100, width: 100, offsetX: 300, offsetY: 100, annotations: [{ content: 'Node2' }]
  },
  {
    id: 'group', children: ['node1', 'node2', 'connector1',], style: { strokeWidth: 0 }
  }];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Runtime group operations

Group nodes at runtime

Groups can be dynamically created during runtime by invoking the diagram.group method. To initiate this process, first select the nodes that should be included within the group. The diagram.group method will encapsulate the selected nodes within a newly formed group node.

The following code illustrates how to group nodes at runtime:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `<button (click)="group()">group selected nodes</button>
     <ejs-diagram #diagram id="diagram" width="100%" height="900px" [nodes]='nodes' (created)='created($event)'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public nodes: NodeModel[] = [
        {
            id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
        },
        {
            id: 'node2', height: 100, width: 100, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
        },
        {
            id: 'node3', height: 100, width: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
        },
    ];
    public created(args: Object): void {
        (this.diagram as DiagramComponent).selectAll();
    }
    public group(): void {
        // Groups the selected nodes and connectors in the diagram.
        (this.diagram as DiagramComponent).group();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Ungroup nodes at runtime

Group nodes can be ungrouped dynamically using the diagram.unGroup method. This operation dissolves the group container while preserving all child elements as individual diagram elements.

The following code example shows how to ungroup a group node at runtime:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, NodeModel, Diagram } from '@syncfusion/ej2-angular-diagrams';
import { DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `<button (click)="unGroup()">unGroup</button>
     <ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes' (created)='created($event)'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public nodes: NodeModel[] = [
        {
            id: 'rectangle1',
            offsetX: 100,
            offsetY: 100,
            width: 100,
            height: 100,
            style: {
                strokeColor: '#6BA5D7',
                fill: '#6BA5D7',
            },
            annotations: [
                {
                    content: 'rectangle1',
                },
            ],
        },
        {
            id: 'rectangle2',
            offsetX: 200,
            offsetY: 200,
            width: 100,
            height: 100,
            style: {
                strokeColor: '#6BA5D7',
                fill: '#6BA5D7',
            },
            annotations: [
                {
                    content: 'rectangle2',
                },
            ],
        },
        {
            id: 'group',
            children: ['rectangle1', 'rectangle2'],
        }
    ];
    public created(args: Object): void {
        (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).getObject('group')]);
    }
    public unGroup(): void {
        // Ungroups the selected nodes and connectors in the diagram.
        (this.diagram as DiagramComponent).unGroup();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add group node at runtime

A group node can be added at runtime using the diagram method diagram.add. This method allows programmatic addition of predefined group structures to an existing diagram.

The following code illustrates how a group node is added at runtime:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]="nodes" (created)='created($event)'>
            </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public nodes: NodeModel[] = [
        {
            id: 'rectangle1',
            offsetX: 100,
            offsetY: 100,
            width: 100,
            height: 100,
            style: {
                strokeColor: '#6BA5D7',
                fill: '#6BA5D7',
            },
            annotations: [
                {
                    content: 'rectangle1',
                },
            ],
        },
        {
            id: 'rectangle2',
            offsetX: 200,
            offsetY: 200,
            width: 100,
            height: 100,
            style: {
                strokeColor: '#6BA5D7',
                fill: '#6BA5D7',
            },
            annotations: [
                {
                    content: 'rectangle2',
                },
            ],
        }
    ];
    public group: NodeModel = {
        id: 'group2',
        children: ['rectangle1', 'rectangle2']
    }
    public created(args: Object): void {
        // Add the group into the diagram
        (this.diagram as DiagramComponent).add(this.group as NodeModel);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add collection of group nodes at runtime

The collection of group nodes can be dynamically added using the addElements method. Each time an element is added to the diagram canvas, the collectionChange event will be triggered.

The following code illustrates how to add group node collections at runtime:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" (created)='created($event)'>
        </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public group: NodeModel = [
        { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: 'node1' }] },
        { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: 'node2' }] },
        { id: 'group', children: ['rectangle1', 'rectangle2'] },
        { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: 'node1' }] },
        { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: 'node2' }] },
        { id: 'group2', children: ['rectangle3', 'rectangle4'], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
    ] as NodeModel;
    public created(args: Object): void {
        // Add the group collection into the diagram
        (this.diagram as DiagramComponent).addElements(this.group as any);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Manage group children at runtime

Add children to group at runtime

A child node can be added to a specified group at runtime using the diagram method diagram.addChildToGroup. This functionality requires passing the group and the existing child node as arguments to the method.

The following code illustrates how a child node can be added to a group node at runtime:

this.diagram.addChildToGroup(groupNode, childNode);

Remove children from group at runtime

A specific child can be removed from a group node at runtime using the diagram method diagram.removeChildFromGroup. This functionality requires passing the group and its child node as arguments to the method.

The following code illustrates how a child node is removed from a group at runtime:

this.diagram.removeChildFromGroup (groupNode, childNode);
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `
    <button (click)="addChild()">addChildToGroup</button>
    <button (click)="removeChild()">removeChildFromGroup</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="600" [nodes]="nodes" >
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public nodes?: NodeModel[];
    ngOnInit(): void {
        this.nodes = [
            {
                id: 'node1', width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
            }, {
                id: 'node2', width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
            }, {
                id: 'group1', children: ['node1', 'node2']
            }, {
                id: 'node3', width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
            }
        ];
    }
    addChild() {
        // Adds the specified diagram object to the specified group node.
        /**
         * parameter 1 - The group node to which the diagram object will be added.
         * parameter 2 - The diagram object to be added to the group.
         */
        (this.diagram as DiagramComponent).addChildToGroup(
            (this.diagram as DiagramComponent).getObject('group1'),
            'node3'
        );
    }
    removeChild() {
        // Removes the specified diagram object from the specified group node.
        /**
         * parameter 1 - The group node from which the diagram object will be removed.
         * parameter 2 - The diagram object to be removed from the group.
         */
        (this.diagram as DiagramComponent).removeChildFromGroup(
            (this.diagram as DiagramComponent).getObject('group1'),
            'node3'
        );
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Group styling and layout

Group padding

The padding property of a group node defines the spacing between the group node’s edges and its children. This property helps maintain visual separation and improves the overall appearance of grouped elements.

The following code illustrates how to add padding to a node group:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes' (created)='created($event)'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Node1' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 200,
      offsetY: 200,
      annotations: [{ content: 'Node2' }],
    },
    {
      id: 'node3',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 300,
      annotations: [{ content: 'Node3' }],
    },
    {
      id: 'group',
      children: ['node1', 'node2', 'node3'],
      // Defines the space between the group node edges and its children
      padding: { left: 20, right: 20, top: 20, bottom: 20 },
    }
  ];
  public created(args: Object): void {
    (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).getObject('group')]);
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Group flip

The flip functionality for a group node works similarly to that of normal nodes. When flipping a group node, the child nodes inherit the group’s flip transformation while retaining their individual flip settings. The combined effect creates a hierarchical flip behavior where both the group and child transformations are applied.

Example of combined flip behavior:

  • If a child node’s flip is set to Vertical and the group node’s flip is set to Horizontal, the resulting flip for the child node combines both transformations (effectively a “both” flip)
  • This ensures that child nodes adapt dynamically based on the group’s flip while maintaining their unique flip settings

The following example shows how to apply flip transformations to group nodes:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, NodeModel, FlipDirection } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      width: 70,
      height: 70,
      offsetX: 100,
      offsetY: 100,
      //Sets the flip as Vertical
      flip: FlipDirection.Vertical,
      shape: {
        type: 'Basic',
        shape: 'RightTriangle',
      },
      style: {
        fill: '#6BA5D7',
      },
    },
    {
      id: 'node2',
      width: 70,
      height: 70,
      offsetX: 180,
      offsetY: 180,
      shape: {
        type: 'Basic',
        shape: 'RightTriangle',
      },
      style: {
        fill: '#6BA5D7',
      },
  
    },
    {
      id: 'group',
      children: ['node1', 'node2',],
      padding: { left: 20, right: 20, top: 20, bottom: 20 },
      //Sets the flip as Horizontal
      flip: FlipDirection.Horizontal,
    }
  ];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Group flip mode

The flipMode property of a group node behaves similarly to that of normal nodes. However, when a flip mode is applied to a group node, it takes precedence over any flip mode set on its child nodes, overriding their individual settings.

Example of flip mode precedence:
In the code below, the flipMode for the child node Node1 is set to LabelText, while the flipMode for the group node is set to Label. The effective flipMode for both the child node and the group node will be Label, as the group node’s flipMode overrides the child’s setting.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, NodeModel, FlipDirection } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      width: 70,
      height: 70,
      offsetX: 100,
      offsetY: 100,
      //Sets the flip mode as LabelText
      flipMode: 'LabelText',
      annotations: [{ content: 'Node1', offset: { x: 0, y: 0.8 } }],
      shape: {
        type: 'Basic',
        shape: 'RightTriangle',
      },
      style: {
        fill: '#6BA5D7',
      },
    },
    {
      id: 'node2',
      width: 70,
      height: 70,
      offsetX: 180,
      offsetY: 180,
      shape: {
        type: 'Basic',
        shape: 'RightTriangle',
      },
      style: {
        fill: '#6BA5D7',
      },

    },
    {
      id: 'group',
      children: ['node1', 'node2',],
      padding: { left: 20, right: 20, top: 20, bottom: 20 },
      annotations: [{ content: 'Group', offset: { x: 0, y: 0.8 } }],
      //Sets the flip as Horizontal
      flip: FlipDirection.Horizontal,
      //Sets the flip mode as Label
      flipMode: 'Label',
    }
  ];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Nested group

Nested groups are groups within groups, where a group can contain other groups as its children, creating a hierarchical structure. This feature helps manage complexity and relationships between different elements in sophisticated diagram scenarios.

Nested Group GIF

The following code illustrates how to create nested group nodes:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes' (created)='created($event)'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public nodes: NodeModel[] = [
      {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Node1' }],
      },
      {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: 'Node2' }],
      },
      {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 350,
        annotations: [{ content: 'Node3' }],
      },
      {
        id: 'node4',
        width: 100,
        height: 100,
        offsetX: 500,
        offsetY: 350,
        annotations: [{ content: 'Node4' }],
      },
      {
        id: 'group1',
        children: ['node1', 'node2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'green' },
      },
      {
        id: 'group2',
        children: ['node3', 'node4'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'skyblue' },
      },
      // Nested Group
      {
        id: 'group3',
        children: ['group1', 'group2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'yellow' },
      }
    ];
    public created(args: Object): void {
        (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).getObject('group3')]);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add groups to symbol palette

Group nodes can be added to the symbol palette like normal nodes, enabling reusable group templates for consistent diagram creation. This feature allows developers to create standardized group configurations that can be dragged and dropped into diagrams.

The following code illustrates how to render group nodes in the palette:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, SymbolPaletteModule, DiagramComponent, NodeModel, PaletteModel, SymbolPaletteComponent } from '@syncfusion/ej2-angular-diagrams';
import { ExpandMode } from '@syncfusion/ej2-navigations';


@Component({
  imports: [
    DiagramModule, SymbolPaletteModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<ejs-symbolpalette #symbolpalette id="symbolpalette" [expandMode]="expandMode" width="30%" [palettes]="palettes" >
      </ejs-symbolpalette>
      <ejs-diagram #diagram id="diagram" width="70%" height="645px" [nodes]='nodes' (created)='created($event)'>
      </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  @ViewChild("symbolpalette")
  public symbolPalette?: SymbolPaletteComponent;
  public expandMode: ExpandMode = 'Multiple';
  public nodes: NodeModel[] = [
    {
      offsetX: 250,
      offsetY: 250,
      width: 100,
      height: 100,
      visible: true,
      style: { fill: '#6AA8D7', strokeWidth: 1 },
    }
  ];
  getSymbols(): NodeModel[] {
    let shapes: NodeModel[] = [
      {
        id: 'n1',
        height: 50,
        width: 50,
        offsetX: 50,
        offsetY: 50,
        style: { fill: 'green' },
      },
      {
        id: 'n2',
        height: 50,
        width: 50,
        offsetX: 100,
        offsetY: 100,
        style: { fill: 'yellow' },
      },
      {
        id: 'group1',
        children: ['n1', 'n2'],
        padding: { left: 10, right: 10, top: 10, bottom: 10 },
      },
      {
        id: 'n3',
        height: 50,
        width: 50,
        offsetX: 100,
        offsetY: 100,
        style: { fill: 'pink' },
      },
      {
        id: 'n4',
        height: 50,
        width: 50,
        offsetX: 100,
        offsetY: 170,
        style: { fill: 'orange' },
      },
      {
        id: 'group2',
        children: ['n3', 'n4'],
        padding: { left: 10, right: 10, top: 10, bottom: 10 },
      },
    ];
    return shapes;
  }
  public palettes: PaletteModel[] = [
    {
      id: 'palette1',
      title: 'Basic Shapes',
      symbols: this.getSymbols(),
      expanded: true,
    }
  ]
  public created(args: Object): void {
    (this.diagram as DiagramComponent).fitToPage({ mode: 'Width' });
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Update group nodes at runtime

Groups can be updated dynamically similar to normal nodes, allowing modification of group properties, styling, and behavior during runtime operations.

The following code illustrates how to update group nodes at runtime:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `<button (click)="updatePadding()">updateGroupPadding</button>
      <button (click)="updateStyle()">updateGroupStyle</button>
      <ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]='nodes'>
      </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'rectangle1',
      offsetX: 100,
      offsetY: 100,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle1',
        },
      ],
    },
    {
      id: 'rectangle2',
      offsetX: 200,
      offsetY: 200,
      width: 100,
      height: 100,
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
      },
      annotations: [
        {
          content: 'rectangle2',
        },
      ],
    },
    {
      id: 'group',
      children: ['rectangle1', 'rectangle2'],
      style: { strokeColor: 'green' },
    },
  ];
  updatePadding() {
    let group: NodeModel = (this.diagram as DiagramComponent).getObject('group');
    (group.padding = { left: 10, right: 10, top: 10, bottom: 10 }), group.style;
    (this.diagram as DiagramComponent).dataBind();
  }
  updateStyle() {
    let group: NodeModel = (this.diagram as DiagramComponent).getObject('group');
    group.style = { fill: 'green' };
    (this.diagram as DiagramComponent).dataBind();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Container types

Containers provide automatic measurement and arrangement of child element size and position according to predefined layout behaviors. The diagram supports two container types, each optimized for different layout scenarios.

Canvas container

The canvas panel supports absolute positioning and provides minimal layout functionality to its contained diagram elements. This container type offers maximum flexibility for precise element placement.

Canvas container characteristics:

  • Supports absolute positioning using margin and alignment properties
  • Enables rendering operations independently for each contained element
  • Allows elements to be aligned vertically or horizontally
  • Child elements are defined using the canvas.children property
  • Basic elements can be defined within the basicElements collection

Stack container

The stack panel arranges its children in a single line or stack order, either vertically or horizontally. This container provides structured layout control through spacing and alignment properties.

Stack container characteristics:

  • Controls spacing using margin properties of child elements and padding properties of the group
  • Default orientation is vertical
  • Provides consistent alignment and distribution of child elements
  • Ideal for creating organized, sequential layouts

The following code illustrates how to add a stack panel:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, Diagram, NodeModel, TextElement, StackPanel, PointModel, VerticalAlignment, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults] ='getNodeDefaults' [setNodeTemplate]="setNodeTemplate">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100>
                <e-node-annotations>
                    <e-node-annotation content="Custom Template" [offset]='offset' [verticalAlignment]='verticalAlignment'>
                </e-node-annotation>
        </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public offset?: PointModel = { y: 1 };
    public verticalAlignment?: VerticalAlignment = 'Top';

    public getNodeDefaults(node: NodeModel): NodeModel {
        node.height = 100;
        node.width = 100;
        ((node as NodeModel).style as ShapeStyleModel).fill = '#6BA5D7';
        ((node as NodeModel).style as ShapeStyleModel).strokeColor = 'white';
        return node;
    }
    public setNodeTemplate(obj: NodeModel | any, diagram: Diagram): StackPanel | undefined {
        if (obj.id.indexOf('node1') !== -1) {
            let table: StackPanel = new StackPanel();
            table.orientation = 'Horizontal';
            // stack panel - column 1
            let column1: StackPanel = new StackPanel();
            column1.children = [];
            // add coloumn 1 text element
            let textElement1: TextElement = new TextElement();
            textElement1.width = 50;
            textElement1.height = 20;
            textElement1.content = 'Column1';
            column1.children.push(textElement1);
            // row 1
            let row11: TextElement = new TextElement();
            row11.width = 50;
            row11.height = 20;
            row11.content = 'Row1';
            column1.children.push(row11);
            // row 2
            let row12: TextElement = new TextElement();
            row12.width = 50;
            row12.height = 20;
            row12.content = 'Row2';
            column1.children.push(row12);
            //row 3
            let row13: TextElement = new TextElement();
            row13.width = 50;
            row13.height = 20;
            row13.content = 'Row3';
            column1.children.push(row13);
            // row 4
            let row14: TextElement = new TextElement();
            row14.width = 50;
            row14.height = 20;
            row14.content = 'Row4';
            column1.children.push(row14);
            // stack panel - column 2
            let column2: StackPanel = new StackPanel();
            column2.children = [];
            // add coloumn 2 text element
            let textElement2: TextElement = new TextElement();
            textElement2.width = 50;
            textElement2.height = 20;
            textElement2.content = 'Column2';
            column2.children.push(textElement2);
            // row 1
            let row21: TextElement = new TextElement();
            row21.width = 50;
            row21.height = 20;
            row21.content = 'Row1';
            column2.children.push(row21);
            // row 2
            let row22: TextElement = new TextElement();
            row22.width = 50;
            row22.height = 20;
            row22.content = 'Row2';
            column2.children.push(row22);
            // row 3
            let row23: TextElement = new TextElement();
            row23.width = 50;
            row23.height = 20;
            row23.content = 'Row3';
            column2.children.push(row23);
            // row 4
            let row24: TextElement = new TextElement();
            row24.width = 50;
            row24.height = 20;
            row24.content = 'Row4';
            column2.children.push(row24);
            // add both the coloumn stack panel as children of a horizontal stack panel
            table.children = [column1, column2];
            return table;
        }
        return undefined;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Difference between basic groups and containers

Basic Group Container
Arranges child elements based on the child elements’ position and size properties Each container has predefined behavior to measure and arrange child elements. Canvas and stack containers are supported in the diagram
The padding, minimum, and maximum size properties are not applicable for basic groups These properties are applicable for containers
The children’s margin and alignment properties are not applicable for basic groups These properties are applicable for containers

Group interactions

Group node interactions can be performed similarly to normal nodes. Fundamental diagram interactions like selecting, dragging, resizing, and rotating apply equally to group nodes. For more information, refer to the node interactions documentation.

Selecting group nodes

When a child element within a node group is clicked, the entire containing node group is selected instead of the individual child element. Subsequent clicks on the selected element change the selection from top to bottom within the hierarchy, moving from the parent node group to its children.

Group Interactions GIF

Events

The events triggered when interacting with group nodes are similar to those for individual nodes. For more information, refer to the node events documentation.

See Also

Syncfusion AI Assistant

How can I help you?

Group in React Diagram Component

21 Oct 202524 minutes to read

Groups enable developers to cluster multiple nodes and connectors into a single manageable element, acting as a container that maintains relationships between child elements while allowing both collective and individual manipulation. This powerful feature streamlines complex diagram management by treating related elements as cohesive units while preserving the ability to edit individual components when needed.

Create Group

A group functions as a container for its children (nodes, groups, and connectors). Every change made to the group affects all children proportionally, while child elements remain individually editable. Groups can contain other groups, creating nested hierarchies for complex diagram structures.

Add Group when Initializing Diagram

A group can be added to the diagram model through nodes collection. To define an object as group, add the child objects to the children collection of the group. The following code illustrates how to create a group node.

  • While creating group, its child node need to be declared before the group declaration.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    },
];
const getNodeDefaults = (node) => {
    node.height = 100;
    node.width = 100;
    node.strokeColor = "White";
    return node;
}
function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'1000px'} height={'600px'}
        nodes={nodes} getNodeDefaults={getNodeDefaults}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";
const nodes: NodeModel = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    },
];
const getNodeDefaults = (node: NodeModel): NodeModel => {
    node.height = 100;
    node.width = 100;
    node.strokeColor = "White";
    return node;
}
function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'1000px'} height={'600px'}
        nodes={nodes} getNodeDefaults={getNodeDefaults}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Connectors can be added to a group. The following code illustrates how to add connectors into a group.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
const connectors = [{
    id: 'connector1', type: 'Orthogonal', sourceID: 'node1', targetID: 'node2'
},
];
const nodes = [{
    id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
},
{
    id: 'node2', height: 100, width: 100, offsetX: 300, offsetY: 100, annotations: [{ content: 'Node2' }]
},
{
    id: 'group', children: ['node1', 'node2', 'connector1',], style: { strokeWidth: 0 }
}];
function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'1000px'} height={'700px'} nodes={nodes} connectors={connectors}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import { DiagramComponent, ConnectorModel, NodeModel } from "@syncfusion/ej2-react-diagrams";
const connectors: ConnectorModel[] = [{
    id: 'connector1', type: 'Orthogonal', sourceID: 'node1', targetID: 'node2'
},
];
const nodes: NodeModel[] = [{
    id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
},
{
    id: 'node2', height: 100, width: 100, offsetX: 300, offsetY: 100, annotations: [{ content: 'Node2' }]
},
{
    id: 'group', children: ['node1', 'node2', 'connector1',], style: { strokeWidth: 0 }
}];
function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'1000px'} height={'700px'} nodes={nodes} connectors={connectors}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Runtime Group Operations

Group Nodes at Runtime

Groups can be dynamically created during runtime in the diagram by invoking the diagram.group method. To initiate this process, first, select the nodes that you intend to include within the group. Subsequently, by utilizing the diagram.group method will encapsulate the selected nodes within a newly formed group node.

The following code illustrates how to group at runtime.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
    },
    {
        id: 'node2', height: 100, width: 100, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
    },
    {
        id: 'node3', height: 100, width: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
    },
];

function App() {
    const diagramRef = useRef(null);
    const group = () => {
        //Groups the selected nodes and connectors.
        diagramRef.current.group();
    }
    return (
        <div>
            <button onClick={group}>Group Selected Nodes</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="900px" nodes={nodes}
                created={() => {
                    diagramRef.current.selectAll();
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel[] = [
    {
        id: 'node1', height: 100, width: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
    },
    {
        id: 'node2', height: 100, width: 100, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
    },
    {
        id: 'node3', height: 100, width: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
    },
];

function App() {
    const diagramRef = useRef(null);
    const group = () => {
        //Groups the selected nodes and connectors.
        diagramRef.current.group();
    }
    return (
        <div>
            <button onClick={group}>Group Selected Nodes</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="900px" nodes={nodes}
                created={() => {
                    diagramRef.current.selectAll();
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Ungroup Nodes at Runtime

Group node can be unGrouped dynamically using the diagram.unGroup method.This operation dissolves the group container while preserving all child elements as individual diagram elements.
The following code example shows how to ungroup a group node at runtime:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    }
];

function App() {
    const diagramRef = useRef(null);
    const unGroup = () => {
        //Ungroups the selected nodes and connectors.
        diagramRef.current.unGroup();
    }
    return (
        <div>
            <button onClick={unGroup}>UnGroup</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="600px" nodes={nodes}
                created={() => {
                    diagramRef.current.select([diagramRef.current.getObject('group')]);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel[] = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
    }
];

function App() {
    const diagramRef = useRef(null);
    const unGroup = () => {
        //Ungroups the selected nodes and connectors.
        diagramRef.current.unGroup();
    }
    return (
        <div>
            <button onClick={unGroup}>UnGroup</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="600px" nodes={nodes}
                created={() => {
                    diagramRef.current.select([diagramRef.current.getObject('group')]);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Add Group Node at Runtime

A group node can be added at runtime by using the diagram method diagram.add.This method allows programmatic addition of predefined group structures to an existing diagram.

The following code illustrates how a group node is added at runtime:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    }
];
const group = {
    id: 'group2',
    children: ['rectangle1', 'rectangle2']
}

function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="600px" nodes={nodes}
                created={() => {
                    // Add the group into the diagram
                    diagramRef.current.add(group);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel[] = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    }
];
const group: NodeModel = {
    id: 'group2',
    children: ['rectangle1', 'rectangle2']
}

function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="600px" nodes={nodes}
                created={() => {
                    // Add the group into the diagram
                    diagramRef.current.add(group);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Add Collection of Group Nodes at Runtime

The collection of group nodes can be dynamically added using the addElements method.Each time an element is added to the diagram canvas, the collectionChange event will be triggered.

The following code illustrates how to add group nodes collection at runtime.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const group = [
    { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group', children: ['rectangle1', 'rectangle2'] },
    { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group2', children: ['rectangle3', 'rectangle4'], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
];

function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="500px"
                created={() => {
                    // Add nodes collection into the diagram
                    diagramRef.current.addElements(group);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const group: NodeModel[] = [
    { id: "rectangle1", offsetX: 100, offsetY: 100, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle2", offsetX: 200, offsetY: 200, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group', children: ['rectangle1', 'rectangle2'] },
    { id: "rectangle3", offsetX: 400, offsetY: 400, width: 100, height: 100, annotations: [{ content: 'node1' }] },
    { id: "rectangle4", offsetX: 500, offsetY: 500, width: 100, height: 100, annotations: [{ content: 'node2' }] },
    { id: 'group2', children: ['rectangle3', 'rectangle4'], padding: { left: 10, right: 10, top: 10, bottom: 10 } },
];

function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="500px"
                created={() => {
                    // Add nodes collection into the diagram
                    diagramRef.current.addElements(group);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Manage Group Children at Runtime

Add Children to Group at Runtime

A child node can be added to a specified group at runtime using the diagram method diagram.addChildToGroup. This functionality requires passing the group and the existing child node as arguments to the method.

The following code illustrates how a child node can be added to a group node at runtime:

diagram.addChildToGroup(groupNode, childNode);

Remove Children from Group at Runtime

A specific child from a group node can be removed at runtime by utilizing the diagram method diagram.removeChildFromGroup. This functionality requires passing the group and its child node as arguments to the method.

The following code illustrates how a child node is removed from a group at runtime:

diagram.removeChildFromGroup (groupNode, childNode);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'node1', width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
    }, {
        id: 'node2', width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
    }, {
        id: 'group1', children: ['node1', 'node2']
    }, {
        id: 'node3', width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
    }
];

function App() {
    const diagramRef = useRef(null);
    const addChild = () => {
        // Adds the specified diagram object to the specified group node.
        /**
         * parameter 1 - The group node to which the diagram object will be added.
         * parameter 2 - The diagram object to be added to the group.
         */
        diagramRef.current.addChildToGroup(
            diagramRef.current.getObject('group1'),
            'node3'
        );
    }
    const removeChild = () => {
        // Removes the specified diagram object from the specified group node.
        /**
         * parameter 1 - The group node from which the diagram object will be removed.
         * parameter 2 - The diagram object to be removed from the group.
         */
        diagramRef.current.removeChildFromGroup(
            diagramRef.current.getObject('group1'),
            'node3'
        );
    }
    return (
        <div>
            <button onClick={addChild}>AddChildToGroup</button>
            <button onClick={removeChild}>RemoveChildFromGroup</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="600px" nodes={nodes}
                created={() => {
                    diagramRef.current.select([diagramRef.current.getObject('group1')]);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel[] = [
    {
        id: 'node1', width: 150, height: 100, offsetX: 100, offsetY: 100, annotations: [{ content: 'Node1' }]
    }, {
        id: 'node2', width: 80, height: 130, offsetX: 200, offsetY: 200, annotations: [{ content: 'Node2' }]
    }, {
        id: 'group1', children: ['node1', 'node2']
    }, {
        id: 'node3', width: 100, height: 100, offsetX: 300, offsetY: 300, annotations: [{ content: 'Node3' }]
    }
];

function App() {
    const diagramRef = useRef(null);
    const addChild = () => {
        // Adds the specified diagram object to the specified group node.
        /**
         * parameter 1 - The group node to which the diagram object will be added.
         * parameter 2 - The diagram object to be added to the group.
         */
        diagramRef.current.addChildToGroup(
            diagramRef.current.getObject('group1'),
            'node3'
        );
    }
    const removeChild = () => {
        // Removes the specified diagram object from the specified group node.
        /**
         * parameter 1 - The group node from which the diagram object will be removed.
         * parameter 2 - The diagram object to be removed from the group.
         */
        diagramRef.current.removeChildFromGroup(
            diagramRef.current.getObject('group1'),
            'node3'
        );
    }
    return (
        <div>
            <button onClick={addChild}>AddChildToGroup</button>
            <button onClick={removeChild}>RemoveChildFromGroup</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="600px" nodes={nodes}
                created={() => {
                    diagramRef.current.select([diagramRef.current.getObject('group1')]);
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Group Styling and Layout

Group Padding

The Padding property of a group node defines the spacing between the group node’s edges and its children. This property helps maintain visual separation and improves the overall appearance of grouped elements.

The following code illustrates how to add padding to a node group:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
const nodes = [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Node1' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: 'Node2' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: 'Node3' }],
    },
    {
        id: 'group',
        children: ['node1', 'node2', 'node3'],
        // Defines the space between the group node edges and its children
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
    }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";
const nodes: NodeModel[] = [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Node1' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: 'Node2' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: 'Node3' }],
    },
    {
        id: 'group',
        children: ['node1', 'node2', 'node3'],
        // Defines the space between the group node edges and its children
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
    }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Group Flip

The flip functionality for a group node works similarly to that of normal nodes. When flipping a group node, the child nodes inherit the group’s flip transformation while retaining their individual flip settings. The combined effect creates a hierarchical flip behavior where both the group and child transformations are applied.

Example of combined flip behavior:

  • If a child node’s flip is set to Vertical and the group node’s flip is set to Horizontal, the resulting flip for the child node combines both transformations (effectively a “both” flip).
  • This ensures that child nodes adapt dynamically based on the group’s flip while maintaining their unique flip settings.

The following example shows how to apply flip transformations to group nodes:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent,FlipDirection } from "@syncfusion/ej2-react-diagrams";
const nodes = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip as Vertical
        flip: FlipDirection.Vertical,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
      },
      {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
    
      },
      {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
        style: {
          fill: 'white', strokeColor:'black'
        },
      }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel, FlipDirection } from "@syncfusion/ej2-react-diagrams";
const nodes: NodeModel[] = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip as Vertical
        flip: FlipDirection.Vertical,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
      },
      {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
    
      },
      {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
        style: {
          fill: 'white', strokeColor:'black'
        },
      }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Group Flip Mode

The flipModeproperty of a group node behaves similarly to that of normal nodes. However, when a flip mode is applied to a group node, it takes precedence over any flip mode set on its child nodes, overriding their individual settings.

Example of flip mode precedence:
In the code below, the flipMode for the child node Node1 is set to LabelText, while the flipMode for the group node is set to Label. The effective flipMode for both the child node and the group node will be Label, as the group node’s flipMode overrides the child’s setting.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, FlipDirection } from "@syncfusion/ej2-react-diagrams";
const nodes = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip mode as LabelText
        flipMode:'LabelText',
        annotations:[{content:'Node1',offset:{x:0,y:0.8}}],
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
      },
      {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
    
      },
      {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        annotations:[{content:'Group',offset:{x:0,y:0.8}}],
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
        //Sets the flip mode as Label
        flipMode:'Label',
        style: {
          fill: 'white', strokeColor:'black'
        },
      }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel, FlipDirection } from "@syncfusion/ej2-react-diagrams";
const nodes: NodeModel[] = [
    {
        id: 'node1',
        width: 70,
        height: 70,
        offsetX: 100,
        offsetY: 100,
        //Sets the flip mode as LabelText
        flipMode:'LabelText',
        annotations:[{content:'Node1',offset:{x:0,y:0.8}}],
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
      },
      {
        id: 'node2',
        width: 70,
        height: 70,
        offsetX: 180,
        offsetY: 180,
        shape: {
          type: 'Basic',
          shape: 'RightTriangle',
        },
        style: {
          fill: '#6BA5D7',
        },
    
      },
      {
        id: 'group',
        children: ['node1', 'node2',],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        annotations:[{content:'Group',offset:{x:0,y:0.8}}],
        //Sets the flip as Horizontal
        flip: FlipDirection.Horizontal,
        //Sets the flip mode as Label
        flipMode:'Label',
        style: {
          fill: 'white', strokeColor:'black'
        },
      }
];

function App() {
    const diagramRef = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramRef} width={'100%'} height={'600px'}
        nodes={nodes}
        created={() => {
            diagramRef.current.select([diagramRef.current.getObject('group')]);
        }}
    />);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Nested Group

Nested groups are groups within groups, where a group can contain other groups as its children, creating a hierarchical structure. This feature helps manage complexity and relationships between different elements in sophisticated diagram scenarios.

Nested Group GIF

The following code illustrates how to create nested group nodes:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Node1' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: 'Node2' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 350,
        annotations: [{ content: 'Node3' }],
    },
    {
        id: 'node4',
        width: 100,
        height: 100,
        offsetX: 500,
        offsetY: 350,
        annotations: [{ content: 'Node4' }],
    },
    {
        id: 'group1',
        children: ['node1', 'node2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'green' },
    },
    {
        id: 'group2',
        children: ['node3', 'node4'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'skyblue' },
    },
    // Nested Group
    {
        id: 'group3',
        children: ['group1', 'group2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'yellow' },
    }
];

function App() {
    const diagramRef = useRef(null);
    return (
        <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="600px" nodes={nodes}
            created={() => {
                diagramRef.current.select([diagramRef.current.getObject('group3')]);
            }}
        />
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel = [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Node1' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 200,
        offsetY: 200,
        annotations: [{ content: 'Node2' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 350,
        annotations: [{ content: 'Node3' }],
    },
    {
        id: 'node4',
        width: 100,
        height: 100,
        offsetX: 500,
        offsetY: 350,
        annotations: [{ content: 'Node4' }],
    },
    {
        id: 'group1',
        children: ['node1', 'node2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'green' },
    },
    {
        id: 'group2',
        children: ['node3', 'node4'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'skyblue' },
    },
    // Nested Group
    {
        id: 'group3',
        children: ['group1', 'group2'],
        padding: { left: 20, right: 20, top: 20, bottom: 20 },
        style: { fill: 'yellow' },
    }
];

function App() {
    const diagramRef = useRef(null);
    return (
        <DiagramComponent id="diagram" ref={diagramRef} width="100%" height="600px" nodes={nodes}
            created={() => {
                diagramRef.current.select([diagramRef.current.getObject('group3')]);
            }}
        />
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Add Groups to Symbol Palette

Group nodes can be added to the symbol palette like normal nodes, enabling reusable group templates for consistent diagram creation. This feature allows developers to create standardized group configurations that can be dragged and dropped into diagrams.

The following code illustrates how to render group nodes in the palette:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, SymbolPaletteComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        offsetX: 250,
        offsetY: 250,
        width: 100,
        height: 100,
        visible: true,
        style: { fill: '#6AA8D7', strokeWidth: 1 },
    }
];
export function getSymbols() {
    let shapes = [
        {
            id: 'n1',
            height: 50,
            width: 50,
            offsetX: 50,
            offsetY: 50,
            style: { fill: 'green' },
        },
        {
            id: 'n2',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: 'yellow' },
        },
        {
            id: 'group1',
            children: ['n1', 'n2'],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
        {
            id: 'n3',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: 'pink' },
        },
        {
            id: 'n4',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 170,
            style: { fill: 'orange' },
        },
        {
            id: 'group2',
            children: ['n3', 'n4'],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
    ];
    return shapes;
}
const palettes = [
    {
        id: 'palette1',
        title: 'Basic Shapes',
        symbols: getSymbols(),
        expanded: true,
    }
]
function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <SymbolPaletteComponent id="symbolpalette" width="30%" palettes={palettes} />
            <DiagramComponent id="diagram" ref={diagramRef} width="70%" height="645px" nodes={nodes}
                created={() => {
                    diagramRef.current.fitToPage({ mode: 'Width' });
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, SymbolPaletteComponent, PaletteModel, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel[] = [
    {
        offsetX: 250,
        offsetY: 250,
        width: 100,
        height: 100,
        visible: true,
        style: { fill: '#6AA8D7', strokeWidth: 1 },
    }
];
export function getSymbols(): NodeModel[] {
    let shapes: NodeModel[] = [
        {
            id: 'n1',
            height: 50,
            width: 50,
            offsetX: 50,
            offsetY: 50,
            style: { fill: 'green' },
        },
        {
            id: 'n2',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: 'yellow' },
        },
        {
            id: 'group1',
            children: ['n1', 'n2'],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
        {
            id: 'n3',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 100,
            style: { fill: 'pink' },
        },
        {
            id: 'n4',
            height: 50,
            width: 50,
            offsetX: 100,
            offsetY: 170,
            style: { fill: 'orange' },
        },
        {
            id: 'group2',
            children: ['n3', 'n4'],
            padding: { left: 10, right: 10, top: 10, bottom: 10 },
        },
    ];
    return shapes;
}
const palettes: PaletteModel[] = [
    {
        id: 'palette1',
        title: 'Basic Shapes',
        symbols: getSymbols(),
        expanded: true,
    }
]
function App() {
    const diagramRef = useRef(null);
    return (
        <div>
            <SymbolPaletteComponent id="symbolpalette" width="30%" palettes={palettes} />
            <DiagramComponent id="diagram" ref={diagramRef} width="70%" height="645px" nodes={nodes}
                created={() => {
                    diagramRef.current.fitToPage({ mode: 'Width' });
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Update Group Nodes at Runtime

Groups can be updated dynamically similar to normal nodes, allowing modification of group properties, styling, and behavior during runtime operations.

The following code illustrates how to update group nodes at runtime:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

const nodes = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
        style: { strokeColor: 'green' },
    },
];

function App() {
    const diagramRef = useRef(null);
    const updatePadding = () => {
        let group = diagramRef.current.getObject('group');
        //Update group padding 
        (group.padding = { left: 10, right: 10, top: 10, bottom: 10 }), group.style;
        diagramRef.current.dataBind();
    }
    const updateStyle = () => {
        let group = diagramRef.current.getObject('group');
        //Update group style 
        group.style = { fill: 'green' };
        diagramRef.current.dataBind();
    }
    return (
        <div>
            <button onClick={updatePadding}>UpdateGroupPadding</button>
            <button onClick={updateStyle}>UpdateGroupStyle</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="900px" nodes={nodes}
                created={() => {
                    diagramRef.current.selectAll();
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";

const nodes: NodeModel = [
    {
        id: 'rectangle1',
        offsetX: 100,
        offsetY: 100,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle1',
        }],
    },
    {
        id: 'rectangle2',
        offsetX: 200,
        offsetY: 200,
        width: 100,
        height: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7',
        },
        annotations: [{
            content: 'rectangle2',
        }],
    },
    {
        id: 'group',
        children: ['rectangle1', 'rectangle2'],
        style: { strokeColor: 'green' },
    },
];


function App() {
    const diagramRef = useRef(null);
    const updatePadding = () => {
        let group: NodeModel = diagramRef.current.getObject('group');
        //Update group padding 
        group.padding = { left: 10, right: 10, top: 10, bottom: 10 };
        diagramRef.current.dataBind();
    }
    const updateStyle = () => {
        let group: NodeModel = diagramRef.current.getObject('group');
        //Update group style
        group.style = { fill: 'green' };
        diagramRef.current.dataBind();
    }
    return (
        <div>
            <button onClick={updatePadding}>UpdateGroupPadding</button>
            <button onClick={updateStyle}>UpdateGroupStyle</button>
            <DiagramComponent id="diagram" ref={diagramRef} width="100%"
                height="900px" nodes={nodes}
                created={() => {
                    diagramRef.current.selectAll();
                }}
            />
        </div>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Container Types

Containers provide automatic measurement and arrangement of child element size and position according to predefined layout behaviors. The diagram supports two container types, each optimized for different layout scenarios.

Canvas Container

The canvas panel supports absolute positioning and provides minimal layout functionality to its contained diagram elements. This container type offers maximum flexibility for precise element placement.

Canvas Container Characteristics:

  • Supports absolute positioning using margin and alignment properties.
  • Enables rendering operations independently for each contained element.
  • Allows elements to be aligned vertically or horizontally.
  • Child elements are defined using the canvas.children property.
  • Basic elements can be defined within the basicElements collection.

The following code illustrates how to add canvas panel.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import { DiagramComponent, DiagramElement, Canvas } from "@syncfusion/ej2-react-diagrams";
let canvas;
let child1;
let child2;
canvas = new Canvas();
canvas.pivot = {
    x: 0,
    y: 0
};
canvas.offsetX = 75;
canvas.offsetY = 75;
canvas.style.fill = '#6BA5D7';
child1 = new DiagramElement();
child1.id = 'child1';
child1.width = 100;
child1.height = 100;
child1.margin.left = child1.margin.top = 10;
child2 = new DiagramElement();
child2.id = 'child2';
child2.width = 100;
child2.height = 100;
child2.margin.left = 190;
child2.margin.right = 5;
child2.margin.top = 190;
child2.margin.bottom = 5;
canvas.children = [child1, child2];
function App() {
    const diagramInstance = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramInstance} mode={'SVG'} width={'1000px'} height={'600px'} 
    // Defines the basic elements
    basicElements={[canvas]}/>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import {
    Diagram,
    DiagramComponent,
    DiagramElement,
    Canvas
} from "@syncfusion/ej2-react-diagrams";
let canvas: Canvas;
let child1: DiagramElement;
let child2: DiagramElement;
canvas = new Canvas();
canvas.pivot = {
    x: 0,
    y: 0
};
canvas.offsetX = 75;
canvas.offsetY = 75;
canvas.style.fill = '#6BA5D7';
child1 = new DiagramElement();
child1.id = 'child1';
child1.width = 100;
child1.height = 100;
child1.margin.left = child1.margin.top = 10;
child2 = new DiagramElement();
child2.id = 'child2';
child2.width = 100;
child2.height = 100;
child2.margin.left = 190;
child2.margin.right = 5;
child2.margin.top = 190;
child2.margin.bottom = 5;
canvas.children = [child1, child2];
function App() {
  const diagramInstance: DiagramComponent = useRef(null);
  return (
    <DiagramComponent
      id="diagram"
      ref={diagramInstance}
      mode={'SVG'}
      width={'1000px'}
      height={'600px'}
      // Defines the basic elements
      basicElements={[canvas]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Stack Container

The stack panel arranges its children in a single line or stack order, either vertically or horizontally. This container provides structured layout control through spacing and alignment properties.

Stack Container Characteristics:

  • Controls spacing using margin properties of child elements and padding properties of the group.
  • Default orientationis vertical.
  • Provides consistent alignment and distribution of child elements.
  • Ideal for creating organized, sequential layouts.

The following code illustrates how to add a stack panel:

import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import { DiagramComponent, StackPanel, TextElement } from "@syncfusion/ej2-react-diagrams";
let nodes = [{
        id: 'node5',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        style: {
            strokeColor: '#6BA5D7',
            fill: '#6BA5D7'
        },
        annotations: [{
                content: 'Custom Template',
                offset: {
                    y: 1
                },
                verticalAlignment: 'Top'
            }]
    },];
let count = 11;
let getTextElement = (text) => {
    let textElement = new TextElement();
    textElement.id = "text" + count;
    textElement.width = 50;
    textElement.height = 20;
    textElement.content = text;
    count++;
    return textElement;
};
let addRows = (column) => {
    column.children.push(getTextElement('Row1'));
    column.children.push(getTextElement('Row2'));
    column.children.push(getTextElement('Row3'));
    column.children.push(getTextElement('Row4'));
};
//Intialize Diagram Component
function App() {
    const diagramInstance = useRef(null);
    return (<DiagramComponent id="diagram" ref={diagramInstance} width={900} height={900} nodes={nodes} getNodeDefaults={(node) => {
            node.height = 100;
            node.width = 100;
            node.style.fill = '#6BA5D7';
            node.style.strokeColor = 'white';
            return node;
        }} setNodeTemplate={(obj, diagram) => {
            if (obj.id.indexOf('node5') !== -1) {
                // It will be replaced with grid panel
                let table = new StackPanel();
                table.orientation = 'Horizontal';
                table.padding.left;
                let column1 = new StackPanel();
                column1.children = [];
                column1.children.push(getTextElement('Column1'));
                addRows(column1);
                let column2 = new StackPanel();
                column2.children = [];
                column2.children.push(getTextElement('Column2'));
                addRows(column2);
                table.children = [column1, column2];
                return table;
            }
            return null;
        }}/>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {useRef} from "react";
import { Diagram, DiagramComponent, NodeModel, StackPanel, TextElement } from "@syncfusion/ej2-react-diagrams";
let nodes: NodeModel[] = [{
    id: 'node5',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7'
    },
    annotations: [{
        content: 'Custom Template',
        offset: {
            y: 1
        },
        verticalAlignment: 'Top'
    }]
}, ];
let count: number = 11;
let getTextElement: Function = (text: string) => {
    let textElement: TextElement = new TextElement();
    textElement.id = "text" + count;
    textElement.width = 50;
    textElement.height = 20;
    textElement.content = text;
    count++;
    return textElement;
};
let addRows: Function = (column: StackPanel) => {
    column.children.push(getTextElement('Row1'));
    column.children.push(getTextElement('Row2'));
    column.children.push(getTextElement('Row3'));
    column.children.push(getTextElement('Row4'));
};
//Intialize Diagram Component
function App() {
  const diagramInstance: DiagramComponent = useRef(null);
  return (
    <DiagramComponent
      id="diagram"
      ref={diagramInstance}
      width={900}
      height={900}
      nodes={nodes}
      getNodeDefaults={(node: NodeModel) => {
        node.height = 100;
        node.width = 100;
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
      }}
      setNodeTemplate={(obj: NodeModel, diagram: Diagram): StackPanel => {
        if (obj.id.indexOf('node5') !== -1) {
          // It will be replaced with grid panel
          let table: StackPanel = new StackPanel();
          table.orientation = 'Horizontal';
          table.padding.left;
          let column1: StackPanel = new StackPanel();
          column1.children = [];
          column1.children.push(getTextElement('Column1'));
          addRows(column1);
          let column2: StackPanel = new StackPanel();
          column2.children = [];
          column2.children.push(getTextElement('Column2'));
          addRows(column2);
          table.children = [column1, column2];
          return table;
        }
        return null;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Difference Between Basic Groups and Containers

Basic Group Container
Arranges child elements based on the child elements’ position and size properties Each container has predefined behavior to measure and arrange child elements. Canvas and stack containers are supported in the diagram
The padding, minimum, and maximum size properties are not applicable for basic groups These properties are applicable for containers
The children’s margin and alignment properties are not applicable for basic groups These properties are applicable for containers

Group Interactions

Group node interactions can be performed similarly to normal nodes. Fundamental diagram interactions like selecting, dragging, resizing, and rotating apply equally to group nodes. For more information, refer to the node interactions documentation.

Selecting Group Nodes

When a child element within a node group is clicked, the entire containing node group is selected instead of the individual child element. Subsequent clicks on the selected element change the selection from top to bottom within the hierarchy, moving from the parent node group to its children.

Group Interactions GIF

Events

The events triggered when interacting with group nodes are similar to those for individual nodes. For more information, refer to the nodes events documentation.

See Also